.. _omp190:

Redundant barrier eliminated. (device only)
====================================================================

This optimization remark indicates that analysis determined an aligned
barrier in the device code to be redundant. This can occur when state
updates that have been synchronized by the barrier were eliminated too.
See also "Co-Designing an OpenMP GPU Runtime and Optimizations for Near-Zero
Overhead Execution", IPDPS'22.

Example
-------

This optimization will trigger for most target regions if state initialization
was removed as a consequence of "state forwarding". This will trigger for
internal runtime functions so it requires enabling verbose remarks with
`-openmp-opt-verbose-remarks` (prefixed with `-mllvm` for use with clang).

Diagnostic Scope
----------------

OpenMP optimization remark.
